package ru.dbotthepony.kstarbound.defs.actor.behavior

import com.google.common.collect.ImmutableList
import com.google.common.collect.ImmutableMap
import com.google.common.collect.ImmutableSet
import com.google.gson.JsonElement
import com.google.gson.JsonObject
import ru.dbotthepony.kstarbound.defs.AssetPath
import ru.dbotthepony.kstarbound.json.builder.JsonFactory

@JsonFactory
data class BehaviorDefinition(
	val name: String,
	val parameters: ImmutableMap<String, JsonElement> = ImmutableMap.of(),
	val scripts: ImmutableSet<AssetPath> = ImmutableSet.of(),
	val root: JsonObject,
) {
	val mappedParameters: ImmutableMap<String, NodeParameterValue> = parameters.entries
		.stream()
		.map { it.key to NodeParameterValue(null, it.value) }
		.collect(ImmutableMap.toImmutableMap({ it.first }, { it.second }))
}
